      program racmb
c Canopy-chemistry model CACHE (Renate Forkel, IMK-IFU)
c
c
      use parameters
      use racm
      use module_kpp_racm_interf
      implicit none

      Integer,parameter ::  IKPP = 1 
      integer,parameter ::  nlev=40,nsoil=15    ! number of levels  
      integer,parameter ::  iwpm2 = 1 
      integer,parameter ::  nspec_old=77, nrect=237
      integer,parameter ::  maxphr=100, maxphpt=100
      Integer,parameter :: ldrog=17  !from MODULE module_data_sorgam  

       real             :: 
     &   ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, 
     &   ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, 
     &   ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, 
     &   ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, 
     &   ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, 
     &   ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, 
     &   ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, 
     &   ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, 
     &   ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, 
     &   ph_mekooh, ph_tolooh, ph_terpooh

        REAL ::
     &          addt, addx, addc, etep, oltp, 
     &          olip, cslp, limp, hc5p, hc8p, 
     &          tolp, xylp, apip, isop, hc3p, 
     &          ethp, o3p, tco3, mo2, o1d, 
     &          olnn, olnd, rpho, xo2, ketp, 
     &          xno2, ol2p, oln, macp

      real,dimension(nlev)       ::  wind 
      double precision,dimension(nlev,nspec_old) ::  vcp
      real,dimension(nspec_old):: vc
      double precision :: Ozone_read, NO_read, NO2_read,CO_read
      double precision :: HCHO_read, NOx_obs_read,averad_obs_read 
      double precision :: averad_obs_Aug26 
      double precision,dimension(23,nlev)    ::  phot1
      double precision,dimension(23):: photoj
      integer :: ntimes
      real    :: clump
      integer :: itime
      integer :: j,iph
      integer :: lev
      real    :: timin
      real    ::  tt, pp, Q2
      real    :: rho_phy
      real    :: moist  ! need moist(i,k,j,P_QV) 
      Integer :: ID  
      REAL    :: vdrog3(ldrog)

      real    :: ratiod,  extf
      double precision :: coszen,zenang
      double precision :: t0, t1, tstart, dtlast
      logical :: lprin
      real    :: eval,potbm2,watabs,potdif,potbm1
      real    :: pid180! check later  
      real    :: axlog, airmas,potvis ,potnir,uu,a 
      real    :: emiss,rlat
      write(*,"(a,3e28.7)"), "ph_acetp=", ph_acetp,ph_o31d, ph_xooh+1
      write(*,*), "ph_acetp=", ph_acetp,ph_o31d, ph_xooh
       data 
     &   ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o, 
     &   ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or, 
     &   ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho, 
     &   ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2, 
     &   ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan, 
     &   ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, 
     &   ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, 
     &   ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, 
     &   ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, 
     &   ph_mekooh, ph_tolooh, ph_terpooh
     &   /48*0/

       data  
     &          addt, addx, addc, etep, oltp, 
     &          olip, cslp, limp, hc5p, hc8p, 
     &          tolp, xylp, apip, isop, hc3p, 
     &          ethp, o3p, tco3, mo2, o1d, 
     &          olnn, olnd, rpho, xo2, ketp, 
     &          xno2, ol2p, oln, macp
     &   /29*0/
      pid180=pi/180.

      CLUMP  = 1.0
 
      timloc=7.           ! start from afternoon of 14.7.2003 
      deltim=60.* 5.0      ! time step in seconds
      ntimes= 60.*60./deltim*18

!      open(33,file="ValuesAtSite_extractedFromWRFchemAug31.txt",
      open(33,file="ValuesAtSite_extractedFromWRFchemAug31.txt_test",
     &                                    ACTION="read")

      read(33,*) 
      read(33,*) 
      read(33,*) 
      read(33,*) 
      read(33,*) 
      read(33,*) 
      read(33,*) 
      read(33,*) 
      call init(vcp,phot1,emiss,wind,rlat,clump)
      lev = 1
      do j=1,nspec_old
c  species concentrations
        vc(j)=vcp(lev,j)
      end do 
      extf=1. ! Test: no photolysis profile

      open(34, file="TS_species.txt",ACTION="WRITE")
         WRITE(34,'(18A9)'), "timloc=", 
     &    "timin", "O3=",
     &    "NO=", "NO2=",
     &    "ISO=","Lim=",
     &    "HONO","HNO3","HNO4","N2O5",
     &    "ONIT","PAN","OH","CO","CH4","H2O"

      do itime=1,ntimes
      photoj( 1)=phot1( 3,lev)          !no2
      photoj( 2)=phot1( 1,lev)          !o3 -> o1d
      photoj( 3)=phot1( 2,lev)          !o3 -> o3p
      photoj( 4)=phot1( 6,lev)          !hono
      photoj( 5)=phot1( 7,lev)          !hno3
      photoj( 6)=phot1( 8,lev)          !ho2no2
      photoj( 7)=phot1( 4,lev)          !no3 -> no
      photoj( 8)=phot1( 5,lev)          !no3 -> no2 + o3p
      photoj( 9)=phot1( 9,lev)          !h2o2
      photoj(10)=phot1(11,lev)          !hcho -> h2 + co
      photoj(11)=phot1(10,lev)          !hcho -> 2 ho2 + co
      photoj(12)=phot1(12,lev)          !ald
      photoj(13)=phot1(18,lev)          !op1
      photoj(14)=phot1(13,lev)          !op2
      photoj(15)=phot1(19,lev)          !paa
      photoj(16)=phot1(14,lev)          !ket
      photoj(17)=phot1(15,lev)          !gly -> 0.13 hcho + 1.87 co
      photoj(18)=phot1(21,lev)          !gly -> 0.45 hcho + 1.55 co + 0.80 ho2
      photoj(19)=phot1(16,lev)          !mgly
      photoj(20)=phot1(17,lev)          !dcb
      photoj(21)=phot1(20,lev)          !onit
      photoj(22)=phot1(22,lev)          !macr
      photoj(23)=phot1(23,lev)          !hket

      tstart=timloc*3600.
      t0=tstart
      t1=tstart+deltim

!      if( mod(timloc*10, 5).eq.0 ) then
       if( mod(itime, 60/(int(deltim)/60) ).eq. 1 .
     &    and.timloc.lt.23.5) then  ! read in every 1 hr
        read(33,*) timin,averad, tt, pp, Q2, 
     &             Ozone_read, NO_read, NO2_read,CO_read,
     &       HCHO_read, NOx_obs_read, averad_obs_read, averad_obs_Aug26    
        print*, "Ozone_read, NO_read, NO2_read",
     &         Ozone_read, NO_read, NO2_read 
         if (NOx_obs_read.le.-999) then
         vc(lno) = max(0.0001,NO_read)*1e-6 
         vc(lno2) = NO2_read*1e-6
         else 
         vc(lno) = max(0.0001,NOx_obs_read/2)*1e-9 
         vc(lno2) = NOx_obs_read/2*1e-9
         end if 
          vc(liso) = 0.36e-9
!          averad = averad_obs_read
          averad = averad_obs_Aug26 

         WRITE(34,'(18f9.3)'), timloc,
     &    timin, vc(lo3)*1e9, 
     &    vc(lno)*1e9, vc(lno2)*1e9,
     &    vc(liso)*1e9, vc(llim)*1e9,
     &    vc(lhono)*1e9,vc(lhno3)*1e9, vc(lhno4)*1e9,
     &    vc(ln2o5)*1e9,vc(lonit)*1e9,vc(lpan)*1e9,
     &    vc(lHO)*1e12 ,vc(lco)*1e9, vc(lch4)*1e9, vc(lh2o)*1e3
100    format(12(A,1x,f7.3,1x))
       endif

      call zenith(coszen,zenang)   ! get coszen

      potvis=0.
      potnir=0.
      if(coszen.gt.0.01 ) then
c  correct for curvature of atmos in airmas
      airmas=(sqrt(coszen**2+.0025)-coszen)/.00125
c  correct for refraction(good to 89.5 deg.)
      airmas=airmas-2.8/(90.-zenang/pid180)**2
      potbm1=600.*exp(-.160*airmas)
      potvis=(potbm1+(600.-potbm1)*.4)*coszen
      potdif=(600.-potbm1)*.4*coszen
      uu=1/coszen
!xhu      axlog=dlog10(uu)
      axlog=log10(uu)
      a=10**(-1.195+.4459*axlog-.0345*axlog*axlog)
      watabs=1320.*a
      potbm2=720.*exp(-.05*airmas)-watabs
      if(potbm2.lt.0.)potbm2=0.
      eval=(720.-potbm2-watabs)*.54*coszen
      potnir=eval+potbm2*coszen
        if(iwpm2.eq.1) then
        ratiod=averad/(potvis+potnir) !  averad includes total solar spectrum (SWdown) in W/m**2
         if (ratiod.lt.0.00001) ratiod = 0.00001   !x zero ratiod would cause problem for photoj
        else
        ratiod=(averad/4.6)/potvis    !  averad is PAR in micromoles per (m2 seconds)
        endif
      endif  

c Convert to  1/s 
      do iph=1,23
      if(coszen.gt.0.) then
      photoj(iph)=photoj(iph)/60.!*ratiod
      photoj(iph)=photoj(iph)*coszen*extf
      else
      photoj(iph)=0.0
      endif
      enddo
      ph_no2      =photoj( 1)          !no2
      ph_o31d     =photoj( 2)          !o3 -> o1d
      ph_o33p     =photoj( 3)          !o3 -> o3p
      ph_hno2     =photoj( 4)          !hono
      ph_hno3     =photoj( 5)          !hno3
      ph_hno4     =photoj( 6)          !ho2no2
      ph_no3o2    =photoj( 7)          !no3 -> no
      ph_no3o     =photoj( 8)          !no3 -> no2 + o3p
      ph_h2o2     =photoj( 9)          !h2o2
      ph_ch2om    =photoj(10)          !hcho -> h2 + co
      ph_ch2or    =photoj(11)          !hcho -> 2 ho2 + co
      ph_ch3cho   =photoj(12)          !ald
      ph_ch3o2h   =photoj(13)          !op1
      ph_ch3coch3 =photoj(14)          !op2
      ph_ch3coo2h =photoj(15)          !paa
      ph_ch3coc2h5=photoj(16)          !ket
      ph_hcocho   =photoj(17)          !gly -> 0.13 hcho + 1.87 co
      ph_hcochob  =photoj(18)          !gly -> 0.45 hcho + 1.55 co + 0.80 ho2
      ph_ch3cocho =photoj(19)          !mgly
      ph_hcochest =photoj(20)          !dcb
      ph_ch3ono2  =photoj(21)          !onit
      ph_macr     =photoj(22)          !macr
      ph_ch3coc2h5=photoj(23)          !hket

      dtlast = 0 !
      lprin = .false.
!      if(itime.eq.61) vc(lo3) = vc(lo3)+100*1e-9
      rho_phy = pp/(tt*287.058)
!      moist = 0.016 !xhu for now kg/kg
      moist = vc(lh2o)*18/28.8 
         WRITE(*,100), "working on timloc before=", timloc,
     &    "timin",timin, "O3=",vc(52)*1e9, 
     &    "NO=",vc(47)*1e9, "NO2=",vc(48)*1e9,
     &    "ISO=",vc(liso)*1e9, "Lim=",vc(40)*1e9,
     &    "photoj",photoj(1),"coszen",coszen,"ratiod",ratiod
      if (IKPP.eq.1) then
       call racm_interface( 
     &   nspec_old, vc, id, deltim, 
     &   pp,tt,rho_phy,moist, 
     &   vdrog3, ldrog, 
     &   addt, addx, addc, etep, oltp, 
     &   olip, cslp, limp, hc5p, hc8p, 
     &   tolp, xylp, apip, isop, hc3p, 
     &   ethp, o3p, tco3, mo2, o1d, 
     &   olnn, olnd, rpho, xo2, ketp, 
     &   xno2, ol2p, oln, macp, 
     &   ph_o31d, ph_o33p, ph_no2, ph_no3o2, ph_no3o,
     &   ph_hno2, ph_hno3, ph_hno4, ph_h2o2, ph_ch2or,
     &   ph_ch2om, ph_ch3cho, ph_ch3coch3, ph_ch3coc2h5, ph_hcocho,
     &   ph_ch3cocho, ph_hcochest, ph_ch3o2h, ph_ch3coo2h, ph_ch3ono2,
     &   ph_hcochob, ph_macr, ph_n2o5, ph_o2, ph_pan,
     &   ph_acet, ph_mglo, ph_hno4_2, ph_n2o, ph_pooh, 
     &   ph_mpan, ph_mvk, ph_etooh, ph_prooh, ph_onitr, 
     &   ph_acetol, ph_glyald, ph_hyac, ph_mek, ph_open, 
     &   ph_gly, ph_acetp, ph_xooh, ph_isooh, ph_alkooh, 
     &   ph_mekooh, ph_tolooh, ph_terpooh  )
  
      else
       call racmh(t0,t1,tt,pp,vc,nspec_old,photoj,dtlast,lprin)
      end if 
!         WRITE(*,*) "working on itime=", itime, "O3=",vc(52)*1e9,"ppb"
         WRITE(*,100), "working on timloc after=", timloc,
     &    "timin",timin, "O3=",vc(52)*1e9, 
     &    "NO=",vc(47)*1e9, "NO2=",vc(48)*1e9,
     &    "ISO=",vc(liso)*1e9, "Lim=",vc(40)*1e9,
     &    "photoj",photoj(1),"coszen",coszen
        
      timloc=t1/3600.

      end do ! do 100 itime=1,ntimes
      end

c ****************************************************************

      block data
c
      parameter (nlevel=40,nsoil=15)
      implicit double precision (a-h,o-z)
      common/imp/alpha,beta
      common/konst/pi,p0,aaa,bbb,ccc,ddd,ak,r0,r1,grav,cp,xl,tconv

c RACM species
      common/spezies/
     &    LACO3, LADDC, LADDT, LADDX, LALD , LAPI , LAPIP, LCH4,
     &    LCO  , LCO2 , LCSL , LCSLP, LDCB , LDIEN, LETE , LETEP,
     &    LETH , LETHP, LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &    LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET, LHNO3, LHNO4,
     &    LHO  , LHO2 , LHONO, LISO , LISOP, LKET , LKETP, LLIM,
     &    LLIMP, LMACR, LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2,
     &    LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI , LOLIP, LOLND,
     &    LOLNN, LOLT , LOLTP, LONIT, LOP1 , LOP2 , LORA1, LORA2,
     &    LPAA , LPAN , LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &    LTPAN, LUDD , LXO2 , LXYL , LXYLP


      data 
     &    LACO3, LADDC, LADDT, LADDX, LALD , LAPI , LAPIP, LCH4,
     &    LCO  , LCO2 , LCSL , LCSLP, LDCB , LDIEN, LETE , LETEP,
     &    LETH , LETHP, LGLY , LH2  , LH2O , LH2O2, LHC3 , LHC3P,
     &    LHC5 , LHC5P, LHC8 , LHC8P, LHCHO, LHKET, LHNO3, LHNO4,
     &    LHO  , LHO2 , LHONO, LISO , LISOP, LKET , LKETP, LLIM,
     &    LLIMP, LMACR, LMGLY, LMO2 , LN2  , LN2O5, LNO  , LNO2,
     &    LNO3 , LO1D , LO2  , LO3  , LO3P , LOLI , LOLIP, LOLND,
     &    LOLNN, LOLT , LOLTP, LONIT, LOP1 , LOP2 , LORA1, LORA2,
     &    LPAA , LPAN , LPHO , LSO2 , LSULF, LTCO3, LTOL , LTOLP,
     &    LTPAN, LUDD , LXO2 , LXYL , LXYLP
     &  /   1  ,   2  ,   3  ,    4 ,   5  ,   6  ,   7  ,   8
     &    , 9  ,  10  ,  11  ,  12  ,  13  ,  14  ,  15  ,  16
     &    ,17  ,  18  ,  19  ,  20  ,  21  ,  22  ,  23  ,  24
     &    ,25  ,  26  ,  27  ,  28  ,  29  ,  30  ,  31  ,  32
     &    ,33  ,  34  ,  35  ,  36  ,  37  ,  38  ,  39  ,  40
     &    ,41  ,  42  ,  43  ,  44  ,  45  ,  46  ,  47  ,  48
     &    ,49  ,  50  ,  51  ,  52  ,  53  ,  54  ,  55  ,  56
     &    ,57  ,  58  ,  59  ,  60  ,  61  ,  62  ,  63  ,  64
     &    ,65  ,  66  ,  67  ,  68  ,  69  ,  70  ,  71  ,  72
     &    ,73  ,  74  ,  75  ,  76  ,  77/

      end


c ---------------------------------------------------------------------


      subroutine init(vcp,phot1,emiss,wind,rlat,clump)
      use parameters
c Initial profiles of all prognostic variables and many parameters

      implicit double precision (a-h,o-z)
      parameter (nlev=40,nsoil=15)    ! number of levels  
      parameter (nspec_old=77, nrect=237)
      parameter(maxemi=nspec_old) ! maximal number of emissions
      parameter(maxrect=500)
      parameter(maxphr=100, maxphpt=100)

      double precision emivalue(maxemi)
      dimension vcp(nlev,nspec_old), phot1(23,nlev),
     &wind(nlev)
      dimension gr(99)

      common/konst/pii,p0,aaa,bbb,ccc,ddd,ak,r0,r1,grav,cp,xl,tconv
      common/astron/eqtm,decl,sindec,cosdec,decmax,sinlat,coslat,
     1 tanlat,dlong
!x      common/timpar/timloc,deltim,month,jday,iyear,icumdy
      common/atmo1/ t(nlev),theta(nlev),p(nlev),rhoair(nlev)
     & ,relh(nlev)
      common /cpy/ hcpy,htr,tlai,levcpy,levhtr,zrough,sizelf
      common/cpy2/hsoil,hcpys,evtot,etotw(99),contot(99),scond(10,99)
     1,ecpys,cphstr,cpestr,wcpys,evsmic,ihrwet(99)
      common/deg/sunazm,viewzn(99),viewaz(99),nozenv,noazmv
     & ,xintv(20,90)
      common /emissions/ emivalue
      common/height/z(nlev),zf(nlev),dz(nlev),dzf(nlev)
      common/grid/ del,zmin1,zmin2,a0(nlev),b0(nlev),c0(nlev)
      common/inter1/wtp(99),frwet(99),frwtmx,pint(99),pilast(99)
     1,pint1(99),twater
      common/misc1/pi,pid180,pid2,sigma,iwrite(9,99),kmax
      common/misc2/fr(99),ct(99),totlai,df(99)
     &,clai(99),distls(10),itot,itotp1,jtot
      common/misc6/xint,xintz(99),nalpha,ispher,nxintz
      common/photo2/ox,cair,rastom,cucond,d1,bkv,facj,rxcham,rsfac
     &             ,znon,conmin,ic3c4
      common /rad1/emis,emisol,rsoil(3),rleaf(3),tleaf(3),aleaf(3)
     &,expdif(99),rlayr(3,30),tlayr(3,30)
      common /rad2/dstrad(3,10,99),dstnet(10,99),frarea(10,99)
     &,templf(10,99),tsoil
      common /rad3/radabv(3),fbeam1(3),coszen,zenang
     &,ratiod,ration,ratio
      common/rad4/d(3,99),u(3,99),bmflx(3,99),rnet(99),rndiv(99),
     &tsfc,rnlam(3,99)
      common/resis2/radn,anstom,rcut20,rsmin,trsopt,trsmin,trsmax,rsm
     1,rsexp,psi1,psi2
      common/root1/froot(99),resrot(99),rootsm,psixy,psitop,rroot
     1,rootup(99),cpytr,psisum,aroot
      common/soil1/zs(nsoil),sl,dels
      common/soil4/pe,bx,bd,aks,an,ws,asoil,bsoil,csoil,dsoil,esoil
      common/feld/ eta(nsoil),psi(nsoil),psit(nsoil),
     &temp(nsoil),xk(nsoil),psieta(nsoil),
     &psitet(nsoil),xlam(nsoil),axa(nsoil),bxb(nsoil),
     &cxc(nsoil),dxd(nsoil),d1t(nsoil),
     &d2t(nsoil),d1eta(nsoil),d2eta(nsoil),
     &xl11(nsoil),xl22(nsoil),rho0(nsoil),
     &rho1(nsoil),rho22(nsoil),xl210(nsoil),
     &p21(nsoil),p21t(nsoil),h(nsoil),datm(nsoil)
      common/stuetzw/sep(18),sp(18),sek(17),sk(17),
     &sept(10),spt(10),sel(10),sxl(10),
     &cpsi(17,3),ck(16,3),cpsit(9,3),clam(9,3),
     &isp,isk,ispt,isl
      common/intf/ qgrnd,qsatg,tausum,tsum,vsum,tsurf,patm,
     &fnet,gdown,gfnet,afl1,aflh,bfl1,bfl2,bflh
      common/bodk/ etamin,etamax,xkr,por,trefp,trefk,cp3,rho3,
     &feldka,albdry,albwet

      common/stratpar/ stable,vgday,vgn,zrday,zrn,alphaday,alphan
      logical stable

      common /treespec/ isort
      common /inputr/ inrad,iwpm2
      common/efact/ efiso,efterp,efovoc,reflai,
     & splitterp(3),splitovoc(9)
      common/efactneu/ efiso2(2,15),                   !Isopren
     & efapi(2,15),efbpi(2,15),efcam(2,15),eftri(2,15),  !Monoterpene
     & efsab(2,15),efmyr(2,15),efbph(2,15),eflim(2,15),
     & ef18c(2,15),efd3c(2,15),efpci(2,15),efaty(2,15),
     & efaca(2,15),efbca(2,15),efoci(2,15),
     & sovoce(9)

      dimension sterpin(3),sovocin(9)
c--------------------------------------------------------------
c           1      2      3       4     5      6      7      8
c          ACO3   ADDC   ADDT   ADDX   ALD    API    APIP   CH4 
c           9     10     11     12     13     14     15     16
c          CO     CO2    CSL    CSLP   DCB    DIEN   ETE    ETEP
c          17     18     19     20     21     22     23     24
c          ETH    ETHP   GLY    H2     H2O    H2O2   HC3    HC3P
c          25     26     27     28     29     30     31     32
c          HC5    HC5P   HC8    HC8P   HCHO   HKET   HNO3   HNO4
c          33     34     35     36     37     38     39     40
c          HO     HO2    HONO   ISO    ISOP   KET    KETP   LIM 
c          41     42     43     44     45     46     47     48
c          LIMP   MACR   MGLY   MO2    N2     N2O5   NO     NO2 
c          49     50     51     52     53     54     55     56
c          NO3    O1D    O2     O3     O3P    OLI    OLIP   OLND
c          57     58     59     60     61     62     63     64
c          OLNN   OLT    OLTP   ONIT   OP1    OP2    ORA1   ORA2
c          65     66     67     68     69     70     71     72
c          PAA    PAN    PHO    SO2    SULF   TCO3   TOL    TOLP
c          73     74     75     76     77
c          TPAN   UDD    XO2    XYL    XYLP
c--------------------------------------------------------------
c

      pi=4.*atan(1.)
      pid180=pi/180.
      pid2=pi*0.5
      sigma=5.67e-08
      rgas=8.314
      decmax=sin(23.44*pid180)

c Read parameters from file inputn
      open(unit=20,file='inputn',status='unknown')
c
      read(20,*) jday,iyear                      ! ##### Start day and year
      icumdy=jday
      read(20,*) xlat,xlong,stdlng               ! ##### geographical location
      read(20,*) isort                           ! ##### tree type (see plant.f)
      read(20,*) hcpy,htr,levhtr,levcpy,del      ! ##### canopy height, trunk space height, top level of trunk spece, top level of canopy, parameter for grid spacing
      read(20,*) tlai,sizelf                     ! ##### total projected LAI, leaf size
      read(20,*) stable
      read(20,*) vgday,vgn                       ! ##### geostrophic wind (day, night) 
      read(20,*) zrday,zrn,alphaday,alphan       ! ##### roughness height (day, night), wind profile parameters (day, night)
      read(20,*) itot,jmax,jmin,dfmin,clump,kmax 
      read(20,*) inrad, iwpm2                     ! ##### read incoming solar radation (iinrad=1), input is in W/m**2 (iwpm2=1) or micromoles per (m2 seconds) (iwpm2=0) 
      read(20,*) ratiod,ration                   ! modifiers for incoming radiation (only important when incoming radiation is not read from file (i.e. inrad=0)
      read(20,*) emis,emisol, factir
      read(20,*) (rsoil(m),m=1,kmax),(rleaf(m),m=1,kmax), !reflectivities, transmissions
     1(tleaf(m),m=1,kmax)
      nxintz=9

c     write(6,*) xlat,xlong,stdlng
c     write(6,*) isort
c     write(6,*) hcpy,htr,levhtr,levcpy,del
c     write(6,*) tlai,sizelf
c     write(6,*) stable
c     write(6,*) vgday,vgn
c     write(6,*) zrday,zrn,alphaday,alphan
c     write(6,*) itot,jmax,jmin,dfmin,clump,kmax

!      write(06,'(/,"     Canopy between ",f4.1," and ",f4.1," m")') 
!     &htr,hcpy
!      write(06,'(/,"     Canopy levels ",i3," to ",i3)')
!     &levhtr,levcpy
!      write(06,'("     Total LAI=",f4.1,/)') tlai
!      write(06,'("     vgday,vgnight",2f4.1)') vgday,vgn
!      write(06,'("     zrday,zrn,alphaday,alphan",4f5.2)') 
!     & zrday,zrn,alphaday,alphan

c Canopy strcture
c ----------------------------------------------------------------
!xhu      call cpstruct(imunu,gr)
c ----------------------------------------------------------------
c row and plant spacings
      read(20,*)rowspc,plspc,dmax                 ! ##### row and plant spacings
c******************* plant  *************************************************
c
c  this is where stom resis, photosynthesis, resp. etc. parameters
c    are read in, they are to remain fixed.
c  read in rs vs light
!777   read(20,*)rcut20,rsmin,anstom,radn          ! ##### Cuticula resistance, min. stomata resistance, 
c  read rs vs temp
!778   read(20,*)trsopt,trsmax,trsmin,rsexp,rsm    ! #####
c  read rs vs leaf psi
!780   read(20,*)psi1,psi2,cidcai                  ! #####
c  cidcai  if < 0 then use cidca in code else set cidca=cidcai
c  convert potentials from bars to j/kg
      psi1=psi1*100.
      psi2=psi2*100.
c
c  additions to subr inplant for leaf p.s. by farquahr eqs.
!      read(20,*)ic3c4,cair,rastom,cucond,d1,bkv,conmin,rxcham
c  input root resis in m4 kg-1 s-1 (corn=3.e6) assume .6 of plant
c    resistance is in root
!      read(20,*)rroot
!      read(20,*)aroot


c  rxcham blr of one side of leaf in chamber used to meas p.s. (s/m)
c  rastom ratio of stom resis on top and bot of leaf.
c  rsfac  factor to adjust blr by for stom cond or resis ratio(li-6200)
      rsfac=(rastom**2+1.)/(rastom+1.)**2
c  cucond cuticular cond to water (mol/m2/s)
c  d1    vpd for start of stom closure (mbar)
c  d2    vpd for end of stom closure (mbar)
c  bkv   parameter for vpd response of stomata
c

      hpsi=1.
      psitp1=psi1
      psitop=0.


      dlong=(stdlng-xlong)/15.
      sinlat=sin(xlat*pid180)
      coslat=cos(xlat*pid180)
      tanlat=sinlat/coslat
      rlat=xlat*pi/180.

c Solar daclination
c ---------------------------------------------------------------
      call declin 
c ---------------------------------------------------------------
      itotp1=itot+1

c  Height levels 
c ############################################################################
c  For changing the height levels modiy the following variable in file inputn:
c  canopy height 'hcpy', trunk height 'htr', level of canopy top 'levcpy' and 
c  top of trunk space 'levhtr'  
c  Select 'del' to get the desired model domain height (note that not
c  all combinations of hcpy, htr, levcpy, levhtr, and del are reasonable and possible)

      tt=exp((levhtr-1)*del)
      hh=exp((levcpy-1)*del)
      xx=((levcpy-1)*del)/((levhtr-1)*del)
      zmin1=(hcpy-htr*xx)/(hh+xx-tt*xx-1)
      zmin2=(zmin1+htr-zmin1*tt)/((levhtr-1)*del)
      do k=1,nlev
      z(k)=zmin1*exp((k-1)*del)+zmin2*(k-1)*del-zmin1
      enddo

      zf(nlev)=z(nlev)+0.5*(z(nlev)-z(nlev-1))
      do k=1,nlev-1
      zf(k)=0.5*(z(k+1)+z(k))
      if(k.gt.1) dzf(k)=zf(k)-zf(k-1)
      dz(k)=z(k+1)-z(k)
      enddo
      dzf(1)=zf(1)
      dzf(nlev)=dzf(nlev-1)
      dz(nlev)=dz(nlev-1)

      jtot=levcpy-levhtr+1

c Soil levels >>>>>>>>>>>>>> muss noch verbessert werden
      zs(1)=-0.05
      zs(2)=-0.1
      zs(3)=-0.2
      zs(4)=-0.4
      zs(5)=-0.7
      zs(6)=-1.

c Secify leaf area index per layer
c Modify #############################################################
      sumd=0.
      do ii=levhtr+1,levcpy
      jj=ii-levhtr
c     df(jj)=sqrt(float(ii-levhtr))
c     df(jj)= 1. !    (float(ii-levhtr))
c Specify according to your in-canopy layers ###########################
c number of specified layers must be equal levcpy-levhtr-1 #############
      df(1)=0.05
      df(2)=0.1
      df(3)=0.15
      df(4)=0.2
      df(5)=0.15
      df(6)=0.1
      df(7)=0.35
      df(8)=0.5
      df(9)=0.6
      df(10)=0.55
      df(11)=0.35

      sumd=sumd+df(jj)
      enddo
      do ii=1,levcpy-levhtr
      df(ii)=tlai/sumd*df(ii)
!x       write(06,'(" df=",i3,f7.3)') ii,df(ii)
      enddo
      
c
c Initialize atmospheric variables #######################################
c
      if(nlev.gt.99) 
     & write(06,'("Canopy radiation model permits only 99 layers,",
     & " but nlev is ",i4)') nlev 

c wind
      vg= vgn
      zrough=zrn
      ustara=vg/30. 
      alphab=6.95 ! Baldocchi, 1988, Atmos. Env. (results in too small values for wind speed in trunk space)
      alphab=1.2!  ########   
      alphab=alphan

c Wind profile
c ----------------------------------------------------------------------
!      call wprofil(vg,alphab,wind)
c ----------------------------------------------------------------------

      do 10 lev=1,nlev

c pressure
      pres=1013.25*100.  ! Surface presssure, pascal
      p(lev)=pres*((1.0-z(lev)/44308.0)**(1.0/0.19023))

c Temperature ! Modify ##################################################
       t(lev)=299.15 -z(lev)*.0085 !0055
c      if(z(lev).gt.1500.) 
c    &  t(lev)=(300.00 -1500.*.005)- (z(lev)-1500.)*.002
c---------------
c      if(z(lev).lt.28.) t(lev)=290.00 ! +z(lev)*.20 

c      t(lev)=theta(lev)/((100000.0/p(lev))** .286)
       theta(lev)= t(lev)*((100000.0/p(lev))** .286)
      dtleaf=0.


c water vapor (volume mixing ratio [ppmv*10**6], corresponding
c                                          to mole fraction)
c identify species no. of H2O
c     jh2o=specnr(nspec_old,'H2O ')

      do i=1,nspec_old
      vcp(lev,i)=0.
      enddo

c Rel. humidity  ! Modify ##################################################
      relh(lev)=.5
      if(z(lev).lt.500.) 
     &relh(lev)=0.70  -z(lev)*.2/500.          
      p1=relh(lev)*610.7*exp(17.1536*(t(lev)-273.15)
     & /(t(lev)-38.33))
      vcp(lev,lh2o)=p1/p(lev) 

c Chemical compounds (volume mixing ratio [ppmv*10**6], corresponding
c                                          to mole fraction)
c Modify ##########################################################
       xx=0.01
      vcp(lev,lch4)=1.7e-6                  !    ch4
      vcp(lev,lco)=100.0e-9                   !    co
      vcp(lev,lco2)=0.000350                 !    co2
      vcp(lev,lh2)=0.5e-6                   !    h2
      vcp(lev,lh2o2)=0.5e-9 *exp(-z(lev)*0.0001)  !    h2o2
      vcp(lev,lhcho)=1.0e-9*exp(-z(lev)*0.01)   !  hcho   exp(-z(lev)*xx)
      vcp(lev,lhno3)=0.1e-9*exp(-z(lev)*0.01) !    hno3
      vcp(lev,lapi)=0.01e-9*exp(-z(lev)*xx)     !    api
      vcp(lev,llim)=0.03e-9*exp(-z(lev)*xx)   !    lim
      vcp(lev,liso)=0.36e-9*exp(-z(lev)*xx)   !    iso
      vcp(lev,lmacr)=0.01e-9*exp(-z(lev)*xx)   !    macr

      vcp(lev,ln2)=0.781                   !    n2
      vcp(lev,lno)=2e-9 *exp(-z(lev)*0.001)   !    no
      vcp(lev,lno2)= 4e-9*exp(-z(lev)*0.001)  !    no2
      vcp(lev,lo2)=0.209                   !    o2
      vcp(lev,lo3)= 5.0e-9  +z(lev)*.10 e-9    !o3
      if(vcp(lev,lo3).gt.60.e-9) vcp(lev,lo3)=60.e-9
      if(z(lev).gt.1150.) vcp(lev,lo3)=60.e-9

      vcp(lev,leth)=1.2e-9   *exp(-z(lev)*xx)  
      vcp(lev,lete)=0.3e-9   *exp(-z(lev)*xx)     ! i.e.,Ethylene  
      vcp(lev,lald)=2.6e-9   *exp(-z(lev)*0.001)  ! Acetaldhyde, which we have   
      vcp(lev,lket)=2.6e-9   *exp(-z(lev)*0.0001) ! no measurement of higher ketones, thus use Acetone 
      vcp(lev,ltol)=(1.23E-01+4.43E-02)*1e-9   *exp(-z(lev)*xx)   ! Toluene + benzene 
      vcp(lev,lxyl)=0.05e-9    *exp(-z(lev)*xx) !xylene and more reactive aromatics;o-Xylene+m,p-Xylene 
      vcp(lev,lpan)=0.3e-9 *.1   *exp(-z(lev)*xx)  ! no measurement 
      vcp(lev,lora1)=0.3e-9 *.1   *exp(-z(lev)*xx) ! formic acid, no measurement 
      vcp(lev,lora2)=0.3e-9 *.1   *exp(-z(lev)*xx) ! acetic acide and higher acids, no measurement  
      vcp(lev,lora2)=0.03e-9 *.1   *exp(-z(lev)*xx)  
c

      vcp(lev,lhc3)=0.65e-9    *exp(-z(lev)*xx) ! use Propane  
      vcp(lev,lhc5)=(3.69E-02)*1e-9    *exp(-z(lev)*xx) ! use Butane+2-Methylbutane+Pentane 
      vcp(lev,lhc8)=0.02e-9    *exp(-z(lev)*xx) ! use the order of Hexane 
      vcp(lev,lolt)=(6.16E-02)*1e-9    *exp(-z(lev)*xx) ! use Propene 
      vcp(lev,loli)=0.3e-9 *.1   *exp(-z(lev)*xx)  

c Photolysis frequencies
c Constant with height! Will be corrected for current zenith angle and
c in-cammopy extinction with a very simple paramerization in the main program
c before calling the chemistry routine.

c     time units for rate constants : 1/min Values for zenith angle=0
      phot1( 3,lev)=0.542199            !no2
      phot1( 1,lev)=0.184632e-02        !o3 -> o1d
      phot1( 2,lev)=0.288514e-01        !o3 -> o3p
      phot1( 6,lev)=0.119043            !hono
      phot1( 7,lev)=0.412661e-04        !hno3
      phot1( 8,lev)=0.279748e-03        !ho2no2
      phot1( 4,lev)=1.56391             !no3 -> no
      phot1( 5,lev)=12.5313             !no3 -> no2 + o3p
      phot1( 9,lev)=0.477564e-03        !h2o2
      phot1(11,lev)=0.267928e-02        !hcho -> h2 + co
      phot1(10,lev)=0.182312e-02        !hcho -> 2 ho2 + co
      phot1(12,lev)=0.335393e-03        !ald
      phot1(18,lev)=0.325182e-03        !op1
      phot1(13,lev)=0.325182e-03        !op2
      phot1(19,lev)=0.126502e-03        !paa
      phot1(14,lev)=0.593159e-04        !ket
      phot1(15,lev)=0.396512e-02        !gly -> 0.13 hcho + 1.87 co
      phot1(21,lev)=0.158140e-02        !gly -> 0.45 hcho + 1.55 co + 0.80 ho2
      phot1(16,lev)=0.693949e-02        !mgly
      phot1(17,lev)=0.323318e-01        !dcb
      phot1(20,lev)=0.188569e-03        !onit
      phot1(22,lev)=0.101917e-03        !macr
      phot1(23,lev)=0.593159e-04        !hket

  10  continue
      
c First guess for leaf and soil temperature
      do i=1,itotp1
      do j=2,jtot
      templf(i,j)=t(j+levhtr)-273.15+dtleaf !templf bezieht sich zwar auf
		 ! die Schicht und nicht das Niveau, ist aber hier egal
      enddo
      enddo


c  contot(j) is accumulated condensate on leaf in layer j
c  frwet: fraction of wet leaves
      do ii=1,levcpy-levhtr
      pint1(ii)=0.    ! no intercepted rain
      contot(ii)=0.
      frwet(ii)=0.
      enddo
      twater=t(nlev-1)

c Boden ---------------------------------------------------------------
c
      tausum=0.
      vsum=0.
      tsum=0.

c        calculate soil grids
c
      sl=0.005
      dels=1.0
      zs(1)=-1.0e-04
      eps=0.0
      do 30 i=2,nsoil
      eps=eps+dels
   30 zs(i)=-sl*(eps**2)

!      read(20,*)bd,sandfc,siltfc,clayfc  !preliminary soil properties
!      read(20,*) eta                     ! ######### initial soil moisture
!      read(20,*) temp                    ! ######### initial soil temperature
   

      adum=sandfc*alog(1.025)+siltfc*alog(.026)+clayfc*alog(.001)
      bdum=(sandfc*(alog(1.025))**2+siltfc*(alog(.026))**2+clayfc*(alog(
     &.001))**2-adum*adum)**.5
      dgeom=exp(adum)
      sgeom=exp(bdum)
c     compute air entry potential, pe=j/kg
      pes=-.5*dgeom**(-.5)
      bx=-2.*pes+.2*sgeom
      pe=pes*(bd/1.3)**(.67*bx)
      psolid=bd/2.65
      ws=1.-psolid  ! Wird moeglicherweise nur fuer psi gebraucht


c  calc frac of root system extracting water at each node

      tsfc=temp(1)-273.15
      tsurf=temp(1)


c read emission factors for isoprene, monoterpenes and ovoc
c in 10-6 ppm/s bezogen auf 30C und 1000umol Photonen/m**2/s
c Emissionsfaktor von Guenther wurde durch 0.7 dividiert,
c    um Wert auf Blattebene zu erhalten (24.2.98)

      do iguenth=1,2
!      read(20,*) reflaiin      
!      read(20,*) efisoin,efterpin,efovocin     ! ##### Emission factors for plant type 1 and 2
!      read(20,*) sterpin                       ! VOC split for TERP
!      read(20,*) sovocin                       ! VOC split for OVOC
      if(iguenth.eq.isort) then
      reflai=reflaiin
      efiso=efisoin
      efterp=efterpin
      efovoc=efovocin
      do ist=1,3
      splitterp(ist)=sterpin(ist)
      enddo
      do io=1,9
      splitovoc(io)=sovocin(io) 
      enddo
      endif
      enddo

      close(20)
c
c      read soil properties
c
c >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        open(unit=7,file='./fd2dat/lehmst',  ! ######### adapt path if necessary
     &  status='unknown')
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c
      read(7,4999) ibt
      read(7,5000) isp,isk,ispt,isl
      read(7,5001) (sep(i),i=1,isp)
      read(7,5001) (sp(i),i=1,isp)
      read(7,5001) (sek(i),i=1,isk)
      read(7,5001) (sk(i),i=1,isk)
      read(7,5001) (sept(i),i=1,ispt)
      read(7,5001) (spt(i),i=1,ispt)
      read(7,5001) (sel(i),i=1,isl)
      read(7,5001) (sxl(i),i=1,isl)
      read(7,7510) por,feldka,albdry,albwet,etamin
      read(7,7870) xkr,trefp,trefk,cp3,rho3
        close(7)
 7510 format(5f12.3)
 7870 format(5f10.3)
c
c >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        open(unit=8,file='./fd2dat/lehmko',  ! ######### adapt path
     &  status='unknown')
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      read(8,4999) ibt
      do 515 i=1,isp-1
 515  read(8,5222) cpsi(i,1),cpsi(i,2),cpsi(i,3)
      do 516 i=1,isk-1
 516  read(8,5222) ck(i,1),ck(i,2),ck(i,3)
      do 517 i=1,ispt-1
 517  read(8,5222) cpsit(i,1),cpsit(i,2),cpsit(i,3)
      do 518 i=1,isl-1
 518  read(8,5222) clam(i,1),clam(i,2),clam(i,3)
        close(8)
 4999 format(a4)
 5222 format(3e24.16)
 5000 format(6i3)
 5001 format(6e10.3)
c
      etamax=por-por/30.
      patm=p(1)
      tsurf=temp(1)
!xhu      call icsevu(sep,sp,isp,cpsi,isp-1,eta(1),psianf,1,ier)
      psianf=-10.**psianf


      return
      end
